<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetScoreReportsInCDScoreLinkFormat
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetScoreReportsInCDScoreLinkFormat $parameters
     * @return \StructType\GetScoreReportsInCDScoreLinkFormatResponse|bool
     */
    public function GetScoreReportsInCDScoreLinkFormat(\StructType\GetScoreReportsInCDScoreLinkFormat $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GetScoreReportsInCDScoreLinkFormat($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetHistoryReport
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetHistoryReport $parameters
     * @return \StructType\GetHistoryReportResponse|bool
     */
    public function GetHistoryReport(\StructType\GetHistoryReport $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GetHistoryReport($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetHistoryReportGivenCandidate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetHistoryReportGivenCandidate $parameters
     * @return \StructType\GetHistoryReportGivenCandidateResponse|bool
     */
    public function GetHistoryReportGivenCandidate(\StructType\GetHistoryReportGivenCandidate $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GetHistoryReportGivenCandidate($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetNewScoreReports
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetNewScoreReports $parameters
     * @return \StructType\GetNewScoreReportsResponse|bool
     */
    public function GetNewScoreReports(\StructType\GetNewScoreReports $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GetNewScoreReports($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetReportingDates
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetReportingDates $parameters
     * @return \StructType\GetReportingDatesResponse|bool
     */
    public function GetReportingDates(\StructType\GetReportingDates $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GetReportingDates($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetScoreReportsGivenReportingDate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetScoreReportsGivenReportingDate $parameters
     * @return \StructType\GetScoreReportsGivenReportingDateResponse|bool
     */
    public function GetScoreReportsGivenReportingDate(\StructType\GetScoreReportsGivenReportingDate $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GetScoreReportsGivenReportingDate($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\GetHistoryReportGivenCandidateResponse|\StructType\GetHistoryReportResponse|\StructType\GetNewScoreReportsResponse|\StructType\GetReportingDatesResponse|\StructType\GetScoreReportsGivenReportingDateResponse|\StructType\GetScoreReportsInCDScoreLinkFormatResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
